"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.translate = void 0;
var https = __importStar(require("https"));
var querystring = __importStar(require("querystring"));
var md5 = require("md5");
var private_1 = require("./private");
var errorMap = {
    52003: '用户认证失败',
    52004: 'error2',
    52005: 'error3',
    52006: 'error4',
    unknown: '服务器繁忙'
};
// const associationMap = {
//     regionIds: ['region', 'region1Id', 'region2Id', 'region3Id']
// };
//
// const defaultValue = {
//     region: '地区',
//     region1Id: null,
//     region2Id: null,
//     region3Id: null,
// };
// 将信息抽象成几个 maps ，这样我们要用的时候只是把 map 里的值拿过来就行
// 而不需要写 if ... else ...，只要 if ... else ... 超过 5 个，一定要想办法优化掉。
var translate = function (word) {
    var salt = Math.random();
    var sign = md5(private_1.appId + word + salt + private_1.appSecret);
    var from, to;
    if (/[a-zA-Z]/.test(word[0])) {
        // 英译中
        from = 'en';
        to = 'zh';
    }
    else {
        // 中译英
        from = 'zh';
        to = 'en';
    }
    var query = querystring.stringify({
        q: word,
        appid: private_1.appId,
        // from: from, to: to, salt: salt, sign: sign
        from: from,
        to: to,
        salt: salt,
        sign: sign,
    });
    var options = {
        hostname: 'api.fanyi.baidu.com',
        port: 443,
        path: '/api/trans/vip/translate?' + query,
        method: 'GET'
    };
    var request = https.request(options, function (response) {
        var chunks = [];
        response.on('data', function (chunk) {
            chunks.push(chunk);
            // data : 每次下载得到的数据
        });
        response.on('end', function () {
            var string = Buffer.concat(chunks).toString();
            var object = JSON.parse(string);
            if (object.error_code) {
                console.error(errorMap[object.error_code] || object.error_msg);
                process.exit(2); // 退出当前进程
                // 随便给个不是 0 的数字即可
            }
            else {
                object.trans_result.map(function (obj) {
                    console.log(obj.dst);
                });
                process.exit(0); // 0 表示没有错误
            }
        });
    });
    request.on('error', function (e) {
        console.error(e);
    });
    request.end();
};
exports.translate = translate;
